// HPController.h

#ifndef _HPCONTROLLER_h
#define _HPCONTROLLER_h

#if defined(ARDUINO) && ARDUINO >= 100
	#include "arduino.h"
#else
	#include "WProgram.h"
#endif
#include <Arduino.h>
#include <ArduinoJson.h>
#include <Ticker.h>
#include <math.h>
#include <ArduinoOTA.h>
#include <Wire.h>
#include <coredecls.h>                  // settimeofday_cb()
#include <ESPAsyncWebServer.h>
#include <PangolinMQTT.h>
#include <LittleFS.h>
#include "hpWebServer.h"
#include "EepromUtil.h"
#include "SystemState.h"
#include "sensors.h"
#include "ntpTime.h"
#include "debugWeb.h"
#include "ts.hpp"
#include "WiFiWPS.h"
#include "ThermostatUDP.h"
#include "Defrost.h"
#include "hpSchedule.h"
#include "Weather.h"
#include "Passwords.h"

#define FileFS        LittleFS
#define FS_Name       "LittleFS"

//Heat pump control pins (Digital outputs) from PCF8574
constexpr auto VALVE = 0xfe;				//P0
constexpr auto FAN = 0xfd;					//P1
constexpr auto PUMP = 0xfb;					//P2
constexpr auto COMPRESSOR = 0xef;			//P4
constexpr auto PUMPGPIO = 13;				//GPIO for pump as option (USING THCURE BOARD - Fujitsu and Dai)
constexpr auto PUMPGPIO1 = 16;				//GPIO for pump as option (USING IOT THERMOSTAT BOARD)

constexpr auto COMPSTARTDELAY = 120000;		//Minimum delay time between compressor starts (for power fail/reset etc)
constexpr auto TIMEBETWEENDEFROSTS = 300;	//Time between successive defrost cycles
constexpr auto OSWATCH_RESET_TIME = 30;
constexpr auto TEMP_OVERHEAT_RESET = 50;	//Temperature to reset compressor in case of overheat

// 8574A Address 0X70
//#define PCF8574 (0x70 >>1) // 8574A addr 001
constexpr auto  PCF8574 = (0x40 >> 1); // 8574 addr 001

extern AsyncWebSocket ws;
extern AsyncWebSocket wsd;

extern Ticker tickerDefrost;

#endif

